<template>
  <div class="app-container calendar-list-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-select v-model="listQuery.type" clearable placeholder="表彰类型" style="top: -4px; width: 200px">
        <el-option :key="item.type" v-for="item in typeList" :label="item.name" :value="item.type">
        </el-option>
      </el-select>
      <el-button class="filter-item" type="primary" v-waves icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table size="small" :data="list" v-loading="listLoading"
      element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column type="index" label="序号" header-align="center" align="center">
      </el-table-column>
      <el-table-column align="center" min-width="100px" label="标题" prop="title">
        <template slot-scope="scope">
            <router-link :to="{name: 'commendDataList', params: { id: scope.row.commendId }}">
                <div style="color: #337ab7;cursor: pointer;">{{ scope.row.title }}</div>
            </router-link>
        </template>
      </el-table-column>
      <el-table-column align="center" min-width="80px" label="类型" prop="typeName">
      </el-table-column>
      <el-table-column align="center" min-width="80px" label="日期" prop="createTime">
      </el-table-column>
      <el-table-column align="center" label="操作" width="300px" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button :disabled="scope.row.status == 1?true:false" type="primary" size="small" @click="handleUpdate(scope.row, false)">编辑</el-button>
          <el-button :disabled="scope.row.status == 1?true:false" v-if="scope.row.status == 0" type="success" size="small"
            @click="changeState(scope.row.commendId, 1)">开启</el-button>
          <el-button :disabled="scope.row.status == 1?true:false" v-if="scope.row.status == 1" type="warning" size="small"
            @click="changeState(scope.row.commendId, 0)">关闭</el-button>
          <el-button :disabled="scope.row.status == 1?true:false" type="danger" size="mini" @click="handleDelete(scope.row.commendId, -1)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页 -->
    <div class="pagination-container">
      <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
        :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
        layout="total, sizes, prev, pager, next, jumper" :total="total">
      </el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :close-on-click-modal="false" :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible" width="40%">
      <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="80px"
        style="width: 700px; margin-left: 50px">
        <el-form-item label="标题" prop="title">
          <el-input style="width: 350px" v-model="dataForm.title"></el-input>
        </el-form-item>
        <el-form-item label="类型" prop="type">
          <el-select v-model="dataForm.type" filterable placeholder="请选择" style="width: 350px">
            <el-option :key="item.type" v-for="item in typeList" :label="item.name" :value="item.type">
            </el-option>
          </el-select>
        </el-form-item>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>
  
<style>
.demo-table-expand {
  font-size: 0;
}

.demo-table-expand label {
  width: 200px;
  color: #99a9bf;
}

.demo-table-expand .el-form-item {
  margin-right: 0;
  margin-bottom: 0;
}
</style>
  
<script>
import {
  createItem,
  updateItem,
  list,
  state,
  types,
} from "@/api/commendManage";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from "@/components/Tinymce";

export default {
  components: { Tinymce },
  directives: { waves },
  data() {
    return {
      typeList: [],
      list: [
      ],
      total: 0,
      listLoading: false,
      listQuery: {
        page: 1,
        limit: 10,
        type: "",
      },
      dataForm: {
        type: undefined,
        title: undefined,
      },
      dialogFormVisible: false,
      dialogStatus: "",
      textMap: {
        update: "编辑",
        create: "创建",
      },
      rules: {
        title: [{ required: true, message: "标题不能为空", trigger: "blur" }],
        type: [{ required: true, message: "请选择类型", trigger: "blur" }],
      },
    };
  },
  created() {
    this.getTypeList();
    this.getList();
  },
  methods: {
    getTypeList(){
      types().then(response => {
        this.typeList = response.data.data;
      })
    },
    changeState(commendId, index) {
      state({ commendId: commendId, status: index }).then(response => {
        this.$notify({
          title: '成功',
          message: '状态修改成功',
          type: 'success',
          duration: 2000
        })
        this.getList()
      })
    },
    resetForm() {
      this.dataForm = {
        type: undefined,
        title: undefined,
      };
    },
    handleCreate() {
      this.resetForm();

      this.dialogFormVisible = true;
      this.dialogStatus = "create";

      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },
    createData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          createItem(this.dataForm)
            .then(() => {
              this.getList();
              this.dialogFormVisible = false;

              this.$notify({
                title: "成功",
                message: "创建成功",
                type: "success",
                duration: 2000,
              });
              this.reload();
            })
            .catch(() => { });
        }
      });
    },
    getList() {
      this.listLoading = true;
      list(this.listQuery)
        .then((response) => {
          this.list = response.data.data.items;
          this.total = response.data.data.total;
          this.listLoading = false;
        })
        .catch(() => {
          this.list = [];
          this.total = 0;
          this.listLoading = false;
        });
    },

    handleFilter() {
      this.listQuery.page = 1;
      this.getList();
    },

    handleSizeChange(val) {
      this.listQuery.limit = val;
      this.getList();
    },

    handleCurrentChange(val) {
      this.listQuery.page = val;
      this.getList();
    },

    handleUpdate(row) {
      this.dataForm = Object.assign({}, row);
      this.dialogStatus = "update";
      this.dialogFormVisible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].clearValidate();
      });
    },

    updateData() {
      this.$refs["dataForm"].validate((valid) => {
        if (valid) {
          updateItem(this.dataForm).then(() => {
            this.dialogFormVisible = false;
            this.$notify({
              title: "成功",
              message: "更新成功",
              type: "success",
              duration: 2000,
            });
            this.getList();
          });
        }
      });
    },

    handleDelete(commendId, status) {
      this.$confirm("确认删除吗?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          state({commendId:commendId,status:status}).then((response) => {
            this.$notify({
              title: "成功",
              message: "删除成功",
              type: "success",
              duration: 2000,
            });
            this.getList();
          });
        })
        .catch(() => { });
    },
  },
};
</script>
<style>
.ad-avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
  border-color: #409eff;
}

.ad-avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}

.ad-avatar {
  display: block;
}
</style>
  